        SUBROUTINE CHOL(A, N, NN, U, NULLTY, IFAULT)
C
C       ALGORITHM AS6, APPLIED STATISTICS, VOL.17, (1968)
C
C       GIVEN A SYMMETRIC MATRIX ORDER N AS LOWER TRIANGLE IN A( )
C       CALCULATES AN UPPER TRIANGLE, U( ), SUCH THAT UPRIME * U = A.
C       A MUST BE POSITIVE SEMI-DEFINITE.  ETA IS SET TO MULTIPLYING
C       FACTOR DETERMINING EFFECTIVE ZERO FOR PIVOT.
C
        REAL A(NN), U(NN), ETA, ETA2, X, W, ZERO, ZABS, ZSQRT
C
C       THE VALUE OF ETA WILL DEPEND ON THE WORD-LENGTH OF THE 
C       COMPUTER BEING USED.  SEE INTRODUCTORY TEXT.
C
        DATA ETA, ZERO /1.E-5, 0.0/
C
        ZABS(X) = ABS(X)
        ZSQRT(X) = SQRT(X)
C
        IFAULT=1
        IF(N.LE.0) GO TO 100
        IFAULT=3
        IF (NN .NE. N*(N+1)/2) RETURN
        IFAULT=2
        NULLTY=0
        J=1
        K=0
        ETA2 = ETA*ETA
        II=0
C
C       FACTORIZE COLUMN BY COLUMN, ICOL = COLUMN NO.
C
        DO 80 ICOL=1,N
        II=II+ICOL
        X=ETA2*A(II)
        L=0
        KK=0
C
C       IROW = ROW NUMBER WITHIN COLUMN ICOL
C
        DO 40 IROW=1,ICOL
        KK=KK+IROW
        K=K+1
        W=A(K)
        M=J
        DO 10 I=1,IROW
        L=L+1
        IF(I.EQ.IROW) GO TO 20
        W=W-U(L)*U(M)
        M=M+1
   10   CONTINUE
   20   IF(IROW.EQ.ICOL) GO TO 50
        IF(U(L).EQ.ZERO) GO TO 30
        U(K)=W/U(L)
        GO TO 40
   30   IF (W*W .GT. ZABS(X*A(KK))) RETURN
        U(K)=ZERO
   40   CONTINUE
   50   IF (ZABS(W) .LE. ZABS(ETA*A(K))) GOTO 60
        IF(W.LT.ZERO) RETURN
        U(K)=ZSQRT(W)
        GO TO 70
   60   U(K)=ZERO
        NULLTY=NULLTY+1
   70   J=J+ICOL
   80   CONTINUE
        IFAULT=0
  100   RETURN
        END
