
setwd("c:/Example8.1/") 
rm(list=ls()) 
data <- matrix(scan("gse36703.txt"),ncol=14,byrow=T) 
require(EMMIXcontrasts) 

n1 <- 5; n2 <- 6; n3 <- 3 

X <- U <- W <- cbind(rep(c(1,0,0),c(n1,n2,n3)),rep(c(0,1,0),c(n1,n2,n3)),
rep(c(0,0,1),c(n1,n2,n3)))
V <- diag(n1+n2+n3)
ng=9 
set.seed(123456) 

ret <- emmixwire(data, g=ng, ncov=3, nvcov=1, X=X, U=U, W=W,
debug=1, itmax=1000, epsilon=1e-4)

ret$lk; ret$pro; ret$beta; ret$sigma.e; ret$sigma.b; ret$sigma.c

wj <- scores.wire(ret, contrast=c(-0.5,-0.5,1))
mat <- cbind(ret$tau, ret$cluster, wj)
write.table(mat, file="cluster_wj", row.names=T, col.names=F)

wj0 <- wj2.permuted(data, ret, nB=19, contrast=c(-0.5,-0.5,1))
pv <- pvalue.wire(wj,wj0)
wjboot <- array(cbind(wj,wj0))
require(EMMIX) 
set.seed(126) 

initobj <- init.mix(wjboot, g=3, distr="mvt", ncov=3, nkmeans=10, nrandom=10, nhclust=F)
obj <- EMMIX(wjboot, g=3, distr="mvt", ncov=3, clust=NULL, init=initobj, itmax=1000,
epsilon=1e-6, debug=TRUE)

t_score <- (wjboot - 0.3719894)/sqrt(1.224055) 
pv <- 2*(1-pt(abs(t_score),19.79059)) 
pv_wj <- pv[1:37628]
pv_wj[pv_wj==0] <- 1e-16
pv_wj[pv_wj==1] <- 1-(1e-16)
zz <- qnorm(1-pv_wj) 
write.csv(cbind(wj,pv_wj,zz), "z_scores.csv")

# clustering of highly ranked differentially-expressed genes (using Cluster 1 as an example)
source("Nonparametric_clustering.R") 
data <- matrix(scan("gse36703_1_215.txt"),ncol=215,byrow=T) 

n <- nrow(data)
nv <- ncol(data)
corr <- cal.measure(data, nv, measure="spearman")
pairnull <- permuteit(data, n, nv, B=100)
obj <- cutit(pairnull, corr, nv, alpha=0.0002)
Mmatrix <- cal.matrix(corr, nv, obj$cutcorr)
write.csv(Mmatrix, "matrix.csv", row.names=F)
ret <- clustit(corr, obj$pairrsort, Mmatrix, nv, obj$cutoff, obj$cutcorr)
obj[1:2]
write.csv(ret, "output.csv", row.names=F)          # use Excel to remove duplicates




