
setwd("c:/Example2.2/")

data <- matrix(scan("new-thyroid.txt"),ncol=5,byrow=T)

install.packages("mvtnorm")
library(mvtnorm)
require(EMMIX)

set.seed(256)
initobj <- init.mix(data, g=3, distr="mvn", ncov=3, nkmeans=10, nrandom=10, nhclust=F)
obj <- EMMIX(data, g=3, distr="mvn", ncov=3, clust=NULL, init=initobj, itmax=1000, epsilon=1e-6, debug=TRUE)

attributes(obj)
write.csv(cbind(obj$tau,obj$clust),"cluster_3gp.csv")

std <- bootstrap(data, n=215, p=5, g=3, distr="mvn", ncov=3, popPAR=initobj, B=50, replace=TRUE, itmax=1000, epsilon=1e-5)
write.csv(std,"cluster_3gp_se.csv")





























