        SUBROUTINE SYMINV(A, N, NN, C, W, NULLTY, IFAULT)
C
C       ALGORITHM AS7, APPLIED STATISTICS, VOL.17, 1968, P.198.
C
C       FORMS IN C( ) AS LOWER TRIANGLE, A GENERALISED INVERSE
C       OF THE POSITIVE SEMI-DEFINITE SYMMETRIC MATRIX A( )
C       ORDER N, STORED AS LOWER TRIANGLE.
C
        REAL A(NN), C(NN), W(N), X, ZERO, ONE
C
        DATA ZERO, ONE /0.0, 1.0/
C
C       CHOLESKY FACTORIZATION OF A, RESULT IN C
C
        CALL CHOL(A, N, NN, C, NULLTY, IFAULT)
        IF(IFAULT.NE.0) RETURN
C
C       INVERT C & FORM THE PRODUCT (CINV)'*CINV, WHERE CINV IS THE INVERSE
C       OF C, ROW BY ROW STARTING WITH THE LAST ROW.
C       IROW = THE ROW NUMBER, NDIAG = LOCATION OF LAST ELEMENT IN THE ROW.
C
        IROW=N
        NDIAG=NN
   10   L=NDIAG
        IF (C(NDIAG) .EQ. ZERO) GOTO 60
        DO 20 I=IROW,N
        W(I)=C(L)
        L=L+I
   20   CONTINUE
        ICOL=N
        JCOL=NN
        MDIAG=NN
   30   L=JCOL
        X=ZERO
        IF(ICOL.EQ.IROW) X=ONE/W(IROW)
        K=N
   40   IF(K.EQ.IROW) GO TO 50
        X=X-W(K)*C(L)
        K=K-1
        L=L-1
        IF(L.GT.MDIAG) L=L-K+1
        GO TO 40
   50   C(L)=X/W(IROW)
        IF(ICOL.EQ.IROW) GO TO 80
        MDIAG=MDIAG-ICOL
        ICOL=ICOL-1
        JCOL=JCOL-1
        GO TO 30
   60   DO 70 J=IROW,N
        C(L)=ZERO
        L=L+J
   70   CONTINUE
   80   NDIAG=NDIAG-IROW
        IROW=IROW-1
        IF(IROW.NE.0) GO TO 10
        RETURN
        END
